<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPanelSettingSelection ArrayType
 * @subpackage Arrays
 */
class ArrayOfPanelSettingSelection extends AbstractStructArrayBase
{
    /**
     * The PanelSettingSelection
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\PanelSettingSelection[]
     */
    public $PanelSettingSelection;
    /**
     * Constructor method for ArrayOfPanelSettingSelection
     * @uses ArrayOfPanelSettingSelection::setPanelSettingSelection()
     * @param \CustomerManagement\StructType\PanelSettingSelection[] $panelSettingSelection
     */
    public function __construct(array $panelSettingSelection = array())
    {
        $this
            ->setPanelSettingSelection($panelSettingSelection);
    }
    /**
     * Get PanelSettingSelection value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\PanelSettingSelection[]|null
     */
    public function getPanelSettingSelection()
    {
        return isset($this->PanelSettingSelection) ? $this->PanelSettingSelection : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPanelSettingSelection method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPanelSettingSelection method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePanelSettingSelectionForArrayConstraintsFromSetPanelSettingSelection(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPanelSettingSelectionPanelSettingSelectionItem) {
            // validation for constraint: itemType
            if (!$arrayOfPanelSettingSelectionPanelSettingSelectionItem instanceof \CustomerManagement\StructType\PanelSettingSelection) {
                $invalidValues[] = is_object($arrayOfPanelSettingSelectionPanelSettingSelectionItem) ? get_class($arrayOfPanelSettingSelectionPanelSettingSelectionItem) : sprintf('%s(%s)', gettype($arrayOfPanelSettingSelectionPanelSettingSelectionItem), var_export($arrayOfPanelSettingSelectionPanelSettingSelectionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PanelSettingSelection property can only contain items of type \CustomerManagement\StructType\PanelSettingSelection, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PanelSettingSelection value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\PanelSettingSelection[] $panelSettingSelection
     * @return \CustomerManagement\ArrayType\ArrayOfPanelSettingSelection
     */
    public function setPanelSettingSelection(array $panelSettingSelection = array())
    {
        // validation for constraint: array
        if ('' !== ($panelSettingSelectionArrayErrorMessage = self::validatePanelSettingSelectionForArrayConstraintsFromSetPanelSettingSelection($panelSettingSelection))) {
            throw new \InvalidArgumentException($panelSettingSelectionArrayErrorMessage, __LINE__);
        }
        if (is_null($panelSettingSelection) || (is_array($panelSettingSelection) && empty($panelSettingSelection))) {
            unset($this->PanelSettingSelection);
        } else {
            $this->PanelSettingSelection = $panelSettingSelection;
        }
        return $this;
    }
    /**
     * Add item to PanelSettingSelection value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\PanelSettingSelection $item
     * @return \CustomerManagement\ArrayType\ArrayOfPanelSettingSelection
     */
    public function addToPanelSettingSelection(\CustomerManagement\StructType\PanelSettingSelection $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\PanelSettingSelection) {
            throw new \InvalidArgumentException(sprintf('The PanelSettingSelection property can only contain items of type \CustomerManagement\StructType\PanelSettingSelection, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PanelSettingSelection[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\PanelSettingSelection|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\PanelSettingSelection|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\PanelSettingSelection|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\PanelSettingSelection|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\PanelSettingSelection|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PanelSettingSelection
     */
    public function getAttributeName()
    {
        return 'PanelSettingSelection';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\ArrayType\ArrayOfPanelSettingSelection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
